import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
const NAME = 'Commitizen';
const ENABLERS = ['commitizen'];
const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
const PACKAGE_JSON_PATH = 'config.commitizen';
const CONFIG_FILE_PATTERNS = ['.czrc', '.cz.json', 'package.json'];
const findPluginDependencies = async (configFilePath, { manifest, isProduction }) => {
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json' ? manifest.config?.commitizen : await load(configFilePath);
    if (!localConfig)
        return [];
    return localConfig.path ? [localConfig.path] : [];
};
const findDependencies = timerify(findPluginDependencies);
export default {
    NAME,
    ENABLERS,
    isEnabled,
    PACKAGE_JSON_PATH,
    CONFIG_FILE_PATTERNS,
    findDependencies,
};
