import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
import { toProductionEntryPattern } from '../../util/protocols.js';
const NAME = 'Drizzle';
const ENABLERS = ['drizzle-kit'];
const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
const CONFIG_FILE_PATTERNS = ['drizzle.config.{ts,js,json}'];
const findDrizzleDependencies = async (configFilePath) => {
    const localConfig = await load(configFilePath);
    if (!localConfig?.schema)
        return [];
    return [localConfig.schema].flat().map(toProductionEntryPattern);
};
const findDependencies = timerify(findDrizzleDependencies);
export default {
    NAME,
    ENABLERS,
    isEnabled,
    CONFIG_FILE_PATTERNS,
    findDependencies,
};
